#include "formule.hpp"

formule variable(string nom) {
  formule res = new formule_s;
  res->op = o_variable;
  res->nom = new string(nom);
  return res;
}

formule variable(char* nom) {
  formule res = new formule_s;
  res->op = o_variable;
  res->nom = new string(nom);
  return res;
}

formule non(formule arg) {
  formule res = new formule_s;
  res->op = o_non;
  res->arg = arg;
  return res;
}

formule et(formule arg1, formule arg2) {
  formule res = new formule_s;
  res->op = o_et;
  res->arg1 = arg1;
  res->arg2 = arg2;
  return res;
}

formule ou(formule arg1, formule arg2) {
  formule res = new formule_s;
  res->op = o_ou;
  res->arg1 = arg1;
  res->arg2 = arg2;
  return res;
}

formule impl(formule arg1, formule arg2) {
  formule res = new formule_s;
  res->op = o_implique;
  res->arg1 = arg1;
  res->arg2 = arg2;
  return res;
}

formule equiv(formule arg1, formule arg2) {
  formule res = new formule_s;
  res->op = o_equivaut;
  res->arg1 = arg1;
  res->arg2 = arg2;
  return res;
}

void free_all(formule f) {
  switch (f->op) {
  case o_implique:
  case o_equivaut:
  case o_ou:
  case o_et:
    free_all(f->arg1);
    free_all(f->arg2);
    break;
  case o_non:
    free_all(f->arg);
    break;
  case o_variable:
    delete f->nom;
    break;
  }
  delete f;
}


string operateur2string(operateur op) {
  switch (op) {
  case o_variable:
    return "var";
  case o_non:
    return "~";
  case o_et:
    return "/\\";
  case o_ou:
    return "\\/";
  case o_implique:
    return "=>";
  case o_equivaut:
    return "<=>";
  }
}

string formule2string(formule f) {
  switch (f->op) {
  case o_variable: 
    return *(f->nom);
  case o_non:
    return "~" + formule2string(f->arg);
  case o_et:
  case o_ou:
  case o_equivaut:
  case o_implique:
    return "("+formule2string(f->arg1)
      +" "+operateur2string(f->op)+" "
      +formule2string(f->arg2)+")";
  }
}

formule copier(formule f) {
  switch (f->op) {
  case o_variable:
    return variable(* f->nom);
  case o_non:
    return non(copier(f->arg));
  case o_et:
    return et(copier(f->arg1),copier(f->arg2));
  case o_ou:
    return ou(copier(f->arg1),copier(f->arg2));
  case o_implique:
    return impl(copier(f->arg1),copier(f->arg2));
  case o_equivaut:
    return equiv(copier(f->arg1),copier(f->arg2));
  }
}
