#ifndef Formule
#define Formule
#include <string>
#include <set>

using namespace std;

enum operateur {
  o_variable,
  o_non,
  o_et,
  o_ou,
  o_implique,
  o_equivaut
};

struct formule_s {
  operateur op;
  union {
    string * nom;
    struct {
      formule_s * arg1;
      formule_s * arg2;
    };
    formule_s * arg;
  };
};

typedef struct formule_s * formule;

extern formule variable(string nom);
extern formule variable(char* nom);
extern formule non(formule arg);
extern formule et(formule arg1, formule arg2);
extern formule ou(formule arg1, formule arg2);
extern formule impl(formule arg1, formule arg2);
extern formule equiv(formule arg1, formule arg2);
extern string formule2string(formule f);
extern formule copier(formule f);

extern void free_all(formule f);

// Clauses et CNFs
typedef int literal;
typedef set<literal> * clause;
typedef vector<clause> cnf;

#endif
